#ifndef XADMASTER_XADCPU_H
#define XADMASTER_XADCPU_H

/* Programmheader

	Name:		xadCPU.h
	Main:		xadmaster
	Versionstring:	$VER: xadCPU.h 1.0 (02.10.2000)
	Author:		SDI
	Distribution:	Freeware
	Description:	CPU related stuff for xad clients

 1.0   02.10.00 : first version
*/

#include <exec/execbase.h>

/* The defines _M680x0 are done automatically by SAS-C. Do them in makefile
for other compilers. */

#ifdef _M68060
  #define CPUCHECK	if(!(xadMasterBase->xmb_SysBase->AttnFlags & AFF_68060)) return 0;
  #define CPUTEXT	" 060"
#elif defined (_M68040)
  #define CPUCHECK	if(!(xadMasterBase->xmb_SysBase->AttnFlags & AFF_68040)) return 0;
  #define CPUTEXT	" 040"
#elif defined (_M68030)
  #define CPUCHECK	if(!(xadMasterBase->xmb_SysBase->AttnFlags & AFF_68030)) return 0;
  #define CPUTEXT	" 030"
#elif defined (_M68020)
  #define CPUCHECK	if(!(xadMasterBase->xmb_SysBase->AttnFlags & AFF_68020)) return 0;
  #define CPUTEXT	" 020"
#else
  #define CPUCHECK
  #define CPUTEXT
#endif

/* The macro CPUCHECK may be used in xcRecogData() as first command. Best
is to encapsulate the variables also. This reduces the chance to crash the
computer, if a lower CPU exists.
For filesystem clients xc_GetInfo() may be used.

This macro is a security macro only. It is still not very clever to install
wrong CPU version, but if this macro is used, the computer does not crash,
but this client is skipped always.
*/

/* The string CPUTEXT may be used in version string after date. */

#endif /* XADMASTER_XADCPU_H */
